SystemOrganization addCategory: #'Pier-JQuery-Widgets'!

PRStructuresWidget subclass: #PRAjaxSearchWidget
	instanceVariableNames: 'searchText items'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-JQuery-Widgets'!

!PRAjaxSearchWidget class methodsFor: 'accessing-defaults' stamp: 'lr 10/7/2010 13:34'!
defaultMaxItems
	^ 6! !

!PRAjaxSearchWidget class methodsFor: 'accessing-description' stamp: 'lr 9/12/2009 12:49'!
descriptionDropdownList
	^ nil! !

!PRAjaxSearchWidget class methodsFor: 'accessing' stamp: 'lr 9/12/2009 12:49'!
groupLabel
	^ 'Pier Search'! !

!PRAjaxSearchWidget class methodsFor: 'testing' stamp: 'lr 9/12/2009 12:49'!
isAbstract
	^ false! !

!PRAjaxSearchWidget class methodsFor: 'accessing' stamp: 'lr 10/7/2010 13:24'!
label
	^ 'Search Field (jQuery)'! !

!PRAjaxSearchWidget methodsFor: 'accessing' stamp: 'lr 9/12/2009 12:49'!
dropdownList
	^ false! !

!PRAjaxSearchWidget methodsFor: 'rendering' stamp: 'lr 10/7/2010 14:11'!
renderContentOn: html
	html textInput script: (html jQuery this autocomplete
		search: [ :value | self structuresFor: value ]
		labels: [ :value | value menu ]
		callback: [ :value :script |
			script goto: ((self context
				structure: value) 
				urlOn: html) ])! !

!PRAjaxSearchWidget methodsFor: 'private' stamp: 'lr 10/7/2010 13:34'!
structuresFor: aString
	| filtered |
	filtered := (self context root fullTextSearch subString: aString) 
		reject: [ :each | self isFiltered: each ].
	self maxItems isNil
		ifFalse: [ filtered := filtered first: (filtered size min: self maxItems) ].
	^ filtered! !

!PRValueLink methodsFor: '*pier-jquery' stamp: 'lr 10/7/2010 13:18'!
jqAccordionIn: aContext
	<value: 'jq-accordion' comment: 'Display children of the current structure as an accordion.'>
	
	^ self lookupStructure: aContext structure do: [ :structure |
		[ :html |
			html div
				script: html jQuery new accordion;
				with: [
					(aContext enumeratorFor: structure) do: [ :child |
						html div: child menu.
						html div: [
							html rendererInstance 
								visit: child ] ] ] ] ]! !

!PRValueLink methodsFor: '*pier-jquery' stamp: 'lr 10/7/2010 13:22'!
jqTabsIn: aContext
	<value: 'jq-tabs' comment: 'Display children of the current structure as a tabbed widget.'>
	
	^ self lookupStructure: aContext structure do: [ :structure |
		[ :html |
			html div
				script: (html jQuery new tabs
					selected: (self propertyAt: 'selected' ifAbsent: [ 0 ]);
					yourself);
				with: [
					html unorderedList: [
						(aContext enumeratorFor: structure) do: [ :child |
							html listItem: [
								html anchor
									url: (html jQuery ajax
										html: [ :renderer | 
											html rendererInstance 
												renderer: renderer;
												visit: child ];
										fullUrl);
									with: child menu ] ] ] ] ] ]! !
